﻿Public Class fMain

    Private Sub chkUseInt_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkUseInt.CheckedChanged

        ' This checkbox enables/disables the TWAIN user interface
        ' When the user interface is used, all controls in grpConfig are to be disabled

        grpConfig.Enabled = Not chkUseInt.Checked

    End Sub

    Private Sub cmdAcquire_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAcquire.Click

        With AxImageBox1

            ' Select the device shown in the combobox
            .CurrentTwainDevice = cboSelect.SelectedIndex

            ' Only continue of the device is connected
            If .TwainConnected Then

                ' Either use the interface, or set properties from the
                ' various text boxes and the combobox
                If chkUseInt.Checked Then

                    .UseTwainInterface = True

                Else

                    .TwainPixelType = cboPixType.SelectedIndex
                    If IsNumeric(txtRes.Text) Then
                        .TwainResolution = Val(txtRes.Text)
                    End If
                    If IsNumeric(txtTop.Text) And IsNumeric(txtLeft.Text) And IsNumeric(txtRight.Text) _
                     And IsNumeric(txtBtm.Text) Then
                        .SetTwainLayout(Val(txtLeft.Text), Val(txtRight.Text), Val(txtTop.Text), Val(txtBtm.Text))
                    End If
                    .UseTwainInterface = False

                End If

                ' Acquire the image
                .Acquire()

            End If

        End With

    End Sub

    Private Sub cmdGetCur_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdGetCur.Click

        ' Select the TWAIN device, then retrieve the current property
        ' values if it is connected

        With AxImageBox1
            .CurrentTwainDevice = cboSelect.SelectedIndex
            If .TwainConnected Then
                cboPixType.SelectedIndex = .TwainPixelType
                .TwainUnits = csXImageTrial.TxTwainUnits.unInches
                txtRes.Text = .TwainResolution
                txtTop.Text = .TwainTop
                txtLeft.Text = .TwainLeft
                txtRight.Text = .TwainRight
                txtBtm.Text = .TwainBottom
            End If
        End With

    End Sub

    Private Sub cmdSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSave.Click

        ' Save to a file.

        If AxImageBox1.ImageLoaded Then
            AxImageBox1.SaveToFile(txtFileName.Text & cboFileExt.Text)
        End If

    End Sub

    Private Sub fMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim N As Long
        Dim i As Long

        ' Initialise the contents of the various comboboxes

        N = AxImageBox1.TwainDeviceCount

        cboSelect.Items.Clear()
        For i = 1 To N
            cboSelect.Items.Add(AxImageBox1.get_TwainDeviceName(i - 1))
        Next i
        cboSelect.SelectedIndex = 0

        cboPixType.Items.Clear()
        cboPixType.Items.Add("Black/White")
        cboPixType.Items.Add("Greyscale")
        cboPixType.Items.Add("RGB Colour")
        cboPixType.SelectedIndex = 2

        cboFileExt.Items.Clear()
        cboFileExt.Items.Add(".bmp")
        cboFileExt.Items.Add(".gif")
        cboFileExt.Items.Add(".jpg")
        cboFileExt.Items.Add(".pcx")
        cboFileExt.Items.Add(".png")
        cboFileExt.Items.Add(".psd")
        cboFileExt.Items.Add(".tif")
        cboFileExt.SelectedIndex = 0

    End Sub
End Class
